#ifndef ADRESSEN_H
#define ADRESSEN_H

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif

#ifndef _INCLUDE_STDIO_H
#include <stdio.h>
#endif

struct Address {
	struct MinNode node;
	char *name;
	char *firstname;
	char *street;
	char *town;
};

// alloc an address and copy parameters.
struct Address *allocAddress(char *name, char *firstname, char *street, char *town);
// free an address
void freeAddress(struct Address *);
// add an address to the addresslist
void addAddress(struct Address *);

// alloc an address and read from ASCII mask
struct Address *readAddressmask();
// write an address in an ASCII mask
void writeAddressmask(FILE *, struct Address *);
// write addresslist to an ASCII mask
void writeAddresslist(FILE *);

#endif
