#ifndef _INCLUDE_FILEDEFS_H
#define _INCLUDE_FILEDEFS_H

/*
**  $VER: filedefs.h 1.01 (7.2.97)
**  StormC Release 3.0
**
**  '(C) Copyright 1995/96/97 Haage & Partner Computer GmbH'
**	 All Rights Reserved
*/

struct filehandle { 
	struct filehandle *next;
	struct filehandle *pred;
	unsigned int handle;
	int ungetC;
	unsigned int mode;
	unsigned int flags;
	int error;
	void *buffer;
	unsigned int size;
	unsigned int fill;
	unsigned int pos;
	unsigned int bufmode;
	int (*read)(struct filehandle *, void *, unsigned int, unsigned int);
	int (*write)(struct filehandle *, void *, unsigned int);
	int (*eof)(struct filehandle *);
	int (*seek)(struct filehandle *, int, int);
	int (*getch)(struct filehandle *);
	int (*ungetch)(struct filehandle *, int); 
	int (*putch)(struct filehandle *, int);
	int (*flush)(struct filehandle *);
	int (*close)(struct filehandle *);
#ifdef __MIXEDBINARY__
	int (*read2)(struct filehandle *, void *, unsigned int, unsigned int);
	int (*write2)(struct filehandle *, void *, unsigned int);
	int (*eof2)(struct filehandle *);
	int (*seek2)(struct filehandle *, int, int);
	int (*getch2)(struct filehandle *);
	int (*ungetch2)(struct filehandle *, int); 
	int (*putch2)(struct filehandle *, int);
	int (*flush2)(struct filehandle *);
	int (*close2)(struct filehandle *);
#endif // __MIXEDBINARY__
};

#endif
